# ostui change log

## [v1.0.3] 2025-04-08

### Fixed

- clapconf dependency version bump. A bug in clapconf was causing configurations to be processed in the wrong order. This was breaking the tests in virgin environments.


## [v1.0.1] 2025-04-06

### Fixed

- unit tests


## [v1.0.0] 2025-03-31

### Changed

- 
- the queue screenshot to show new features
- screen shots: more, to show the fork changes, and smaller, so it's not just a page of big images
- point to the correct METRICS.md file everywhere
- add a comment about the TUI corruption issue resulting from libmpv
- replace viper with claptrap, reducing executable size by 1.46MB
- never, ever print to stdout/err unless we're immediately exiting. It really screws up tview.
- not finding the logo is a hard error now
- version bump of tview
- change the DB refresh status so that only the S is colored green.
- fix a md lint complaint.
- remove build sheild, because sr.ht doesn't understand git branches
- instead of creating json config files and referencing shields.io to generate the SVGs in the README, just create the SVGs and upload _those_
- upload badges even if it's not a release: badges refer to tip, not the release.
- add a revision SVG

### Fixed

- CI again, because bash's `read` command is stupid and different from every other shell
- CI
- re-added missing plaintext and scrobble arguments, missed in the conversion to claptrap
- unit tests pass again
- an edge case where the artist can't be found could trigger a nil panic because of the incorrect order of error handling

### Removed

- tview-command; which wasn't doing anything, yet.


## [v0.2.2] 2025-03-13

### Changed

- git-cliff doesn't understand using branch names as tags, so went back to changelog
- CI depend on -bin packages as much as possible
- CI assets uploaded to asset server
- badge links
- Trying to get fancy with the CI

### Fixed

- Badge header block markdown
- CI missing dependency & stuff
- CI ripgrep dep was missing

### Removed

- METRICS.md is moved to assets, and is now updated by CI
- devup.sh is now being done in CI


## [v0.2.1
v0.2.1] 2025-03-07

### Added

- govulncheck in CI test step

### Changed

- fixes README linting
- switch from alpine to arch, because alpine doesn't have mpv which is needed to build this
- b/c of the switch to arch, re-enable markdownlint
- addressed linter complaints
- use revive instead of golang-lint in testing

### Fixed

- build AGAIN
- documentation about which linting tools are in use
- CI needs mpv to build
- caught some missed renames
- repaired the unit tests broken by API changes


## [v0.2.0] 2025-03-07

### Changed

- hard fork, project renamed

### Fixed

- lyrics weren't being cleared when songs changed, and song #1 had lyrics but song #2 didn't. This only happened when the song change was automatic.
- the logger could get jammed up by too many messages and cause a race condition with the UI loop


## [v1.0.0] 2025-01-30

### Added

- parameter to enable logging messages to a file
- concurrent album art and lyrics fetching; should improve UI lag on slow server responses
- a more complex caching mechanism which loads assets concurrently, to handle slow asset servers. Abstracted enough to be able to handle caching to disk without having to change users of the Cache.
- visual element reporting whether the server is scanning or not
- ability to check the current scan status of the server, via the `scanStatus` API
- implement `addArtistToQueue`, which is currently unused
- ability to toggle song info panel on queue page via `i` (courtesy of @mahmed2000)
- support for synchronized lyrics (as provided by gonic & Navidrome)
- ability to also write logs to a log file
- search now pro-actively searches until no more results are returned. It still queries in batches of 20, and updates the list(s) as results are available.
- fetch version information from build info
- Makefile compiles binary with derived version
- Makefile test task runs tests & linting
- Makefile generates changelog
- improved documentation about search page; Changes search page focus defaults; Fixes error handling bug in playlists page; Fixes incorrect search help text.
- feature 54: save queue on exit.
- ticket #58, ability to trigger a server library scan
- ticket #11, sort by dis[c]number
- ticket #58, ability to trigger a server library scan
- ticket #11, sort by dis[c]number
- a linting message
- duration to song info
- "shuffle" function to queue
- contributor notes
- hacky commands toml
- first piece of tview-command integration
- homebrew path action
- badges
- similar artist/album/song feature via `getSimilarSongs`
- hacky commands toml
- first piece of tview-command integration
- homebrew path action
- badges
- debug output

### Changed

- a comment in the code inaccurately attributed a problematic gap in the original Subsonic API (corrected in OpenSubsonic) to Navidrome.
- handleEntitySelected was no longer accurately named, and contained dead code
- update changelog
- removes pro-active background loading of playlist data, making the playlist page act more like the other pages: loading subcontent on demand
- playlist lists (such as in the "add song to playlist" function) can now be more accurate. They were being populated once at GUI initialization, and so would always miss newly added playlists.
- lyrics uses binary search instead of linear search to find current lyric.
- adds a work-around for Navidrome not populating the `albumArtist` field in songs
- clientVersion renamed and updated; it's the API version, not the version of the client.
- display the song genre, or the album genre if the server doesn't provide song-level genres
- make `getResponse` private again
- changelog is updated, and readme updated to list the extra merged features
- browser now works on metadata, not directory structure. Not all functions fully tested, but it works.
- rolls back the (unrelated, unnecessary) logger changes
- tweaks the lyrics timing offset to try to hit that sweet spot that makes up for the inaccuracy of mpv
- re-arranges the song info; purely aesthic chang (#81)
- golangci-lint+golang versions in ci
- README.md with new keyboard shortcut
- golangci-lint+golang versions in ci
- README.md with new keyboard shortcut
- README.md with new keyboard shortcut
- per the review
- implementation to be in line with current architecture
- metadata prop on song change and notify receivers
- go-mpv even more
- go-mpv
- go deps

### Fixed

- it should not be an error if a startScan call response returns "scanning: false".
- if a song wasn't playing, the scanning status widget wasn't being updated since it was driven by mpv events
- search item adding regressions
- search page focus improvements
- adding playlist to queue wasn't working (regression)
- entities (songs) names weren't being formatted, e.g. star added. Again, another regression.
- wrong item being starred in browser (indexing bug introduced earlier)
- song info was only being rendered for songs with lyrics
- make sure to clear lyrics when the next song has none
- update README to reflect removing background playlist syncing
- only adds lyrics support if the server has the OpenSubsonic lyrics extension
- entity list wasn't advancing the cursor
- load queue seeking
- replayGain is specific to Navidrome (and is not documented in OpenSubsonic) but I added it to the API in case we want to support it at some point. However, it had the wrong structure, which caused issues with deserialization on Navidrome.
- adding an artist replaces artist in cache with next artist. This is a consequence of the unexpected tview behavior that List.SetChangedFunc calls the callback _before_ changing the value returned by GetCurrentItem; so if the callback calls GetCurrentItem, it'll get the wrong value.
- catch potential NPEs
- 'a' on an artist's album in the browser doesn't add it
- linting
- unit tests
- queue page root was being created twice, and the second time omitted the song info, causing it to not be shown until the user toggled it on
- search page apropos focus now focuses appropriately
- during the merge, a field rename prevented unmarshalling of search results
- lyrics for songs were being loaded in the wrong place, and so weren't updating from song to song unless the album art also changed.
- some (optional?) attributes are provided with different types by gonic and navidrome, which breaks json unmarshalling. To support this, a custom unmarshaller will have to be written; in the meantime, to prevent panics, the attributes have been removed. We aren't using them (yet) anyway.
- issue #88, duplicate key binding for "scan" and "save queue as playlist"
- clear search columns when genre search mode changes
- make sure _something_ other than the search field gets focused on Enter
- clarifies search help text
- user interactions in search page with no results resulting in NPE. (#79)
- second edge case of #33
- #33 selected entry gets stuck
- makefile rule was never updating the change log
- readme linting errors from last commit
- wrong order of args, gofmt all
- merge leftover
- #42: updates screenshots
- linting message about unneeded nil check
- json tag format error
- dis[c]Number field naming; adds display of discNumber in song info
- queue save dialog navigation bug (trying to change an immutable value)
- markdownlint-cli error, and removes a code TODO comment (b/c done)
- #42: updates screenshots
- merge problem
- input capture trickle-down and also prevents global hotkeys from being stolen from the global search input. Also addresses a number of other bugs, and implements load-more.
- input capture trickle-down and also prevents global hotkeys from being stolen from the global search input.
- linter trigger
- badges
- #18
- other mac paths
- #21; playlists are loaded in the background, with a spinner to show the user the ongoing operation.
- linter trigger
- badges
- #18
- indentation (by running gofmt from vscode)
- other mac paths
- dbus player control, improve dbus error handling
- interface name in introspection
- name

### Removed

- cover art caching in connection; caching to be handled by caller.
- some debugging code.
- debug print


## [v2] 2024-08-03

### Added

- missing license headers
- cpu/mem profiling
- a --list option that prints out server information
- a --list option that prints out server information without starting the UI
- missing license headers
- cpu/mem profiling
- quit and help buttons, improve looks
- buttom menu widget
- getprop for bool, use type-safe variants everywhere
- OnSeek callbacks
- mac media center stuff back in
- navidrome example, screenshots, md linter action
- separate linter job to catch macOS-only problems
- license headers and authors file, now that the project has diverged a bit
- libgl dep back
- message box for short error notices
- gui/background event loops
- scrobble timer to submit after delay
- scrobble config example
- golangci-lint github action and pre-commit hook
- subsonic scrobble endpoint support
- toggle star to Entity list
- star toggle to the queue list
- random songs to queue
- "Refresh" to both the artist list, and for individual artists
- "Refresh" to both the artist list, and for individual artists
- plaintext auth support
- #16, sorting by track. The browser list is sorted:
- #16, sorting by track. The browser list is sorted:
- git workflow
- (very basic) support for mpris. Volume, play/pause works with mpris clients e.g. playerctl. No metadata or time updates yet.
- advances cursor in list
- search function for artists
- shields to readme
- to playlist and add playlist to queue are wired up. Why isn't it working???
- duration to queue items
- delete from queue and delete all from queue
- license and updated readme
- libmpv integration. Got very basic list of artists rendering

### Changed

- go-mpv fork to fix macos build
- readme
- screenshot
- 
- README with new keys
- build instructions for OSX

### Fixed

- index panic on refresh operation.
- #8, help dialog can be shown exactly once
- panic on out-of-range array access
- panic on out-of-range array access
- #10
- #8, help dialog can be shown exactly once
- index panic on refresh operation.
- mpris not implementing the right interface
- linux build
- macos build
- warnings
- license headers
- handling when there's only one artist or playlist
- browserPage thing
- crash when starring from entity list
- all errcheck problems
- some missing error checks
- handling of pressing stop while paused and missing queueList update when playing next track (not yet fixed for mpris)
- missing draw call in log
- not being able to remove the first queue track when nothing is playing
- hang on quit, right column title
- a bunch of crashes
- typo
- inappropriate linter error
- linter setup, add go1.15/1.21 build matrix
- nil currentDirectory error
- #36: Adds support for unsalted password auth
- playlist loading on non-Gonic servers
- things with gofmt
- so many import errors
- keybinding documentation
- keybinding documentation
- switching between tracks

### Removed

- whitespace

## Contributors

- git@ptrcnull.me
- 683996+spezifisch@users.noreply.github.com
- spezifisch23@proton.me
- zmoore@squareup.com
- 40123257+wildeyedskies@users.noreply.github.com
- 60757196+xxxserxxx@users.noreply.github.com
- ciiron@pm.me
- daniel@lublin.se
- mahmad2000@protonmail.com
- dweymouth@gmail.com
- zoenb@mailbox.org
- tsuica@curcub.eu
- ser@ser1.net
- lckdscl@bim.boats
- spezifisch+git@gmail.com
- hello@southpaw.dev
- null@null.me.uk

## Todo

1. BUG Sometimes when browsing, we completely lose all of the albums. Refresh doesn't work. Artists can still be added with 'a', but nothing is shown in the entity list. This is hard to reproduce. 
2. REQ document combining Cache with LRU; is a combining wrapper needed? 
3. REQ Add mocking library 
4. REQ Allow fetching credentials from a secret service 
5. REQ Add a toggle to switch the browser to a directory browser 
6. BUG Adding an album from the browser view where the artist has only one song adds the whole album. Adding the one song manually adds the wrong song. Eilish, No Time to Die 
7. BUG verify saving works -- it doesn't look like it's working properly. Gonic: "subsonic error code 50: you aren't allowed update that user's playlist" 
8. REQ Support log levels github.com/d2g/logfilter 
9. REQ Put all "heavy" structures behind a Queue 
10. REQ Don't let connection calls hang up the UI 
11. REQ Test against Navidrome, which is returning different playlists than gonic 
12. REQ Artists that only exist under Various Artists don't show up as their own artists in getArtists calls to either gonic or Navidrome. E.g. if an artist has a single song tagged with artist=X and albumartist=A, living in directory A/somealbum/song.opus, that artist will not appear in getArtists 
13. REQ MprisPlayer.Previous() -- not implemented 
14. REQ MprisPlayer.Seek() -- not implemented 
15. REQ MprisPlayer.SetPosition() -- not implemented 
16. BUG When browsing a Various Artists album that appears under an artist, and the songs are filtered by artist, the indexing is based on the whole album and not the filter. 'y' may favorite the wrong item. 
17. REQ Get unit tests up to some non-embarassing percentage 
18. REQ Support "Download" for songs, albums, artists, and playlists 
19. REQ add filter/search to entity list (albums/songs) 
20. REQ add filter/search to all of the results columns 
21. REQ Add filter/search to playlist coluumn 
22. BUG There's a bug in back-tabbing from cancel; _something_ is disabling the overwriteEnabled field. Tabbing forward works fine, but tabbing backward fails to work properly when the playlist name matches an existing playlist 
23. REQ Update screenshots in the README 
24. REQ createPlaylist could have autocomplete, but it interferes with the list navigation. 
25. REQ browsing genres should autoload the genres, rather than waiting for Enter 
26. REQ Enter on an artist should... what? Add & play? Switch to the Entity list? 
27. REQ make p.queue access thread-safe mutex queue access 
28. REQ make p.queue access thread-safe mutex queue access 
29. REQ make p.queue access thread-safe mutex queue access 
30. REQ Subsonic can provide artist images. Find a place to display them in the browser 
31. REQ is mpvEvent.Data thread-safe? maybe we need a copy 
32. REQ is mpvEvent.Data thread safe? maybe we need a copy 
33. BUG print a useful message and exit, don't panic 
34. REQ Artists under Various Artists don't show up as their own artists?? Gonic or Navidrome. 
35. REQ replace this by a Cache in the client 
36. REQ replace this by a Cache in the client 
37. REQ replace this by a Cache in the client 
38. REQ add version information and compare to server API version undecided
39. REQ mpvEvent.Data thread safe? maybe we need a copy 
40. REQ is mpvEvent.Data thread safe? maybe we need a copy 
